# 1.2.0

## Major Changes

- `withFDHandler` now explicitly flushes the file handle whenever log entries
   are rendered out. Thanks to @filterfish for identifying this omission that
   could lead to log messages being dropped.

   Upgrade steps: no changes other than updating `logging-effect`.

---

# 1.1.3

## Other Changes

- Increased upper bound of `time` to allow < 1.9.

---

# 1.1.2

## Other changes

- Increased upper bound of `time`

---

# 1.1.1

- `withBatchedHandler` no longer prints empty log messages. Previously,
  if you ran a program that didn't log but used `withBatchedHandler` (or anything
  that used that), an empty log message would be output. Thanks to @codedmart
  for fixing this.

---

# 1.1.0

*Breaking changes*:

- `MonadLog` no longer has `logMessage` as a function. It now has
  `logMessageFree` which takes a free monoid of log messages. If you were just
  using `logging-effect` then this won't affect you, as `logMessage` still exists
  with the same signature outside the type class.

- `MonadLog` now comes with a law that states that logging is a monoid
  homomorphism. This essentially means that you have to treat all log messages
  uniformly.

- Pass-through instances for all "stock" monad transformers have been added
  (all of `transformers`, `CatchT` from exceptions and `FreeT`/`FT` from `free`).

- `WithSeverity` now has instances of `Traversable` and `Foldable`

- `WithTimestamp` now has instances of `Eq`, `Ord`, `Read` and `Show`.

*Additions*:

- A set of convenience functions have been added for quickly logging with
  severity. The combinators are: `logDebug`, `logInfo`, `logNotice`,
  `logWarning`, `logError`, `logCritical`, `logAlert` and `logEmergency`.

- `mapLogMessage` got a companion function `mapLogMessageM` that works with
  monadic tranformations.

*Other*

- Many documentation bug fixes.

- INLINEABLE pragmas added.

---

# 1.0.0

- Initial release
